'use strict';
angular.module('aom.directives')
  .directive('aomDateTime', function ($timeout, aomResourcesSrv, constants, aomBackSrv) {
    return {
      scope: {
        field: '=',
        changedMethod: '=',
        shared: '=',
        readonly: '='
      },
      link: function ($scope) {

        function mobiscrollShown(event, inst) {
          inst.position();
        }

        function mobiscrollBeforeShow() {
          return !($scope.field.Options.IsWriteOnce && $scope.field.Data !== '' && $scope.field.Data !== null);
        }

        function setDateTimeSettings() {
          var options = { onShow: mobiscrollShown, onBeforeShow: mobiscrollBeforeShow, dateFormat: aomResourcesSrv.data.resources.Formats.DateFormat, showOnTap: false };
          var buttonTexts = { setText: aomResourcesSrv.data.resources.Common.Done, cancelText: aomResourcesSrv.data.resources.Common.Cancel, clearText: aomResourcesSrv.data.resources.Common.Clear };
          $scope.field.mobiscrollSettings = angular.extend({}, options, $scope.isDateField ? constants.dateSettings : constants.timeSettings, buttonTexts);
        }

        function closeModal(ctId) {
          aomBackSrv.exit();
          mobiscroll.instances[ctId].hide();
        }

        if ($scope.field.Data === null) {
          $scope.field.Data = '';
        } else if ($scope.field.Data !== '') {
          $scope.field.Data = moment($scope.field.Data).toDate();
        }

        $scope.isDateField = $scope.field.Type === constants.fieldTypes.date;

        setDateTimeSettings();

        $scope.show = function ($event) {
          if ($scope.field.Data === null) {
            $scope.field.Data = '';
          } else if ($scope.field.Data !== '') {
            $scope.field.Data = moment($scope.field.Data).toDate();
          }
          if (!$scope.readonly) {
            var ctId = $event.currentTarget ? $event.currentTarget.id : $event.target.id;
            var timeoutLength = 0;
            if ($scope.shared !== undefined) {
              timeoutLength = $scope.shared.keyboardUp ? 500 : 0;
            }
            $timeout(function () {
              aomBackSrv.init(closeModal(ctId));
              mobiscroll.instances[ctId].show();
            }, timeoutLength);
          }
        };

        $scope.mobiscrollChange = function () {
          if ($scope.changedMethod !== undefined) {
            $scope.changedMethod($scope.field.Name);
          }
          setDateTimeSettings();
        };
      },
      templateUrl: 'App/Common/Directives/DateTime/datetime.html'
    };
  });
