'use strict';
angular.module('aom.directives')
  .directive('ngFileSelected', function ($http, $cordovaFile, aomResourcesSrv, constants) {
    return {
      scope: {
        ngFileSelected: '&'
      },
      link: function ($scope, $element, $attrs) {

        $element.on('change', function (event) {
          var file = event.currentTarget.files[0];
          var filename = file.name;
          if (constants.anyFileFromDeviceTypes.indexOf(file.type) > -1) {
            if (file.size / 1024.0 / 1024.0 <= aomResourcesSrv.data.resources.AnyFile.FileSizeLimitInMB) {
              var path = URL.createObjectURL(file);
              var config = {
                headers: { 'Content-Type': file.type },
                responseType: 'blob'
              };
              $http.get(path, config)
                .then(function (file) {
                  return $cordovaFile.writeFile(ionic.Platform.isIOS() ? cordova.file.tempDirectory : cordova.file.cacheDirectory, filename, file.data, true);
                })
                .then(function (success) {
                  URL.revokeObjectURL(path);
                  $scope.ngFileSelected({ $event: success.target.localURL });
                });
            } else {
              $scope.ngFileSelected({ $event: { name: 'ExceedsMaxSizeError' } });
            }
          } else {
            $scope.ngFileSelected({ $event: { name: 'AddDocumentError' } });
          }
          $element[0].value = '';
        });

        $scope.$on('$destroy', function () {
          $element.off();
        });
      }
    };
  });