'use strict';
angular.module('aom.services')
  .factory('aomCustomUriSrv', function ($state, aomPopupSrv, aomResourcesSrv) {
    var customUriService = {};

    customUriService.data = {
      backState: null,
      systemUpload: false
    };


    function navigate() {
      var url = window.localStorage.getItem('external_load');
      window.localStorage.removeItem('external_load');
      var option = url.split('://').pop();
      switch (option) {
        case 'debug':
          customUriService.data.systemUpload = false;
          $state.go('debug');
          break;
        case 'debug/systemUpload':
          customUriService.data.systemUpload = true;
          $state.go('debug');
          break;
        case 'anyfilefromdevice':
          if (!aomResourcesSrv.data.resources.Features.IsEnterprise) {
            aomPopupSrv.alert('EnterpiseFeature', {
              title: aomResourcesSrv.data.resources.Common.Error,
              template: aomResourcesSrv.data.resources.Errors.EnterpriseFeatureOnly,
              onDismiss: function () { }
            });
          }
          break;
        default:
          $state.go($state.current.name);
          break;
      }
    }

    if (window.localStorage.getItem('external_load')) {
      navigate();
    }

    document.addEventListener('aomv4ExternalLoad', navigate);

    customUriService.back = function () {
      $state.go(customUriService.data.backState);
    };

    return customUriService;
  });