angular.module('aom.services')
  .factory('aomRoadsSrv', function ($q, aomLocationSrv, aomAPISrv, aomResourcesSrv) {
    var roads = {};

    roads.getNearest = function () {
      return aomLocationSrv.getCurrentLocation()
        .then(function () {
          var roadObject = {
            CurrentLocation: {
              Latitude: aomLocationSrv.data.lastLocationForServer.latitude,
              Longitude: aomLocationSrv.data.lastLocationForServer.longitude
            },
            DistanceBetweenPoints: getDistanceBetweenPointsInMetres()
          };
          return aomAPISrv.postData(aomAPISrv.data.rootLinks.Roads.href, roadObject);
        })
        .then(function (response) {
          return $q.when(response.data.Roads);
        });
    };

    function getDistanceBetweenPointsInMetres() {
      try {
        return aomResourcesSrv.data.resources.Fields.HttpGet.DistanceBetweenPointsInMetres;
      } catch (err) {
        return 25;
      }
    }

    return roads;
  });