'use strict';
angular.module('aom.services')
  .factory('aomSelectModalSrv', function ($q, $ionicModal, aomPopupSrv, aomHardwareSrv) {

    var selectModalSrv = {};

    selectModalSrv.setupModal = function ($scope, selectType) {
      if (selectModalSrv.modal === undefined) {
        var templateUrl = 'App/Common/Directives/';
        templateUrl += selectType === 'RoadSelect' ? 'RoadSelect/roadSelectOptions.html' : 'Select/selectOptions.html';
        return $ionicModal.fromTemplateUrl(templateUrl, {
          scope: $scope,
          animation: aomHardwareSrv.isTomTom() ? 'none' : 'slide-in-up',
        }).then(function (modal) {
          $scope.modal = modal;
          aomPopupSrv.addModal($scope.selectObject.Name, modal);
          selectModalSrv.modal = modal;
        });
      } else {
        return $q.when();
      }
    };

    selectModalSrv.hideModal = function () {
      if (selectModalSrv.modal) {
        selectModalSrv.modal.hide()
          .then(function () {
            selectModalSrv.modal.remove();
            selectModalSrv.modal = undefined;
          });
      }
      return $q.when();
    };

    return selectModalSrv;
  });
